VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Fraktale"
   ClientHeight    =   8130
   ClientLeft      =   165
   ClientTop       =   555
   ClientWidth     =   8025
   LinkTopic       =   "Form1"
   ScaleHeight     =   8130
   ScaleWidth      =   8025
   StartUpPosition =   2  'CenterScreen
   Begin VB.Menu mnuStart 
      Caption         =   "Start"
   End
   Begin VB.Menu mnuStop 
      Caption         =   "Stop"
      Enabled         =   0   'False
   End
   Begin VB.Menu mnuFraktal 
      Caption         =   "Fraktal"
      Begin VB.Menu mnuChoinka 
         Caption         =   "Choinka"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuSpirala 
         Caption         =   "Spirala"
      End
      Begin VB.Menu mnuTS 
         Caption         =   "Trjkt Sierpiskiego"
      End
      Begin VB.Menu mnusep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuY2Times 
         Caption         =   "Podwjna modyfikacja Y"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Grzegorz Niemirowski
'www.grzegorz.net

Option Explicit

Private Type TParametry
   a As Single
   b As Single
   c As Single
   d As Single
   e As Single
   f As Single
End Type

Dim ParametryChoinka(0 To 3) As TParametry
Dim ParametrySpirala(0 To 1) As TParametry
Dim ParametryTS(0 To 2) As TParametry

Dim sngZoom As Single
Dim sngStartX As Single
Dim sngStartY As Single
Dim intFraktal As Integer
Dim int2Y As Integer
Dim blnRysuj As Boolean

Private Sub Rysuj()
   Dim sngX As Single
   Dim sngY As Single
   Dim lngKrok As Long
   Me.Cls
   Do
      If intFraktal = 0 Then
         If int2Y = 1 Then
            Odwzorowanie2Y sngX, sngY, Int(Rnd * 4), ParametryChoinka()
         Else
            Odwzorowanie sngX, sngY, Int(Rnd * 4), ParametryChoinka()
         End If
      ElseIf intFraktal = 1 Then
         If int2Y = 1 Then
            Odwzorowanie2Y sngX, sngY, Int(Rnd * 2), ParametrySpirala()
         Else
            Odwzorowanie sngX, sngY, Int(Rnd * 2), ParametrySpirala()
         End If
      ElseIf intFraktal = 2 Then
         If int2Y = 1 Then
            Odwzorowanie2Y sngX, sngY, Int(Rnd * 3), ParametryTS()
         Else
            Odwzorowanie sngX, sngY, Int(Rnd * 3), ParametryTS()
         End If
      End If
      Me.PSet (sngX * sngZoom + sngStartX, sngStartY - sngY * sngZoom)
      lngKrok = lngKrok + 1
      If lngKrok Mod 100 = 0 Then
         If intFraktal = 0 Then
            Me.Caption = "Fraktal - choinka [Krok " & lngKrok & "]"
         ElseIf intFraktal = 1 Then
            Me.Caption = "Fraktal - spirala [Krok " & lngKrok & "]"
         ElseIf intFraktal = 2 Then
            Me.Caption = "Fraktal - trjkt Sierpiskiego [Krok " & lngKrok & "]"
         End If
      End If
      DoEvents
   Loop Until blnRysuj = False
End Sub

Private Sub Odwzorowanie(ByRef X As Single, ByRef Y As Single, ByVal intOdwzorowanie, Parametry() As TParametry)
   Dim tmpX As Single
   Dim tmpY As Single
   tmpX = Parametry(intOdwzorowanie).a * X + Parametry(intOdwzorowanie).b * Y + Parametry(intOdwzorowanie).c
   tmpY = Parametry(intOdwzorowanie).d * X + Parametry(intOdwzorowanie).e * Y + Parametry(intOdwzorowanie).f
   X = tmpX
   Y = tmpY
End Sub

Private Sub Odwzorowanie2Y(ByRef X As Single, ByRef Y As Single, ByVal intOdwzorowanie, Parametry() As TParametry)
   X = Parametry(intOdwzorowanie).a * X + Parametry(intOdwzorowanie).b * Y + Parametry(intOdwzorowanie).c
   Y = Parametry(intOdwzorowanie).d * X + Parametry(intOdwzorowanie).e * Y + Parametry(intOdwzorowanie).f
End Sub

Private Sub Form_Load()
   mnuChoinka_Click 'choinka defaultowo
   'choinka
   ParametryChoinka(0).a = -0.67
   ParametryChoinka(0).b = -0.02
   ParametryChoinka(0).c = 0
   ParametryChoinka(0).d = -0.18
   ParametryChoinka(0).e = 0.81
   ParametryChoinka(0).f = 10
   ParametryChoinka(1).a = 0.4
   ParametryChoinka(1).b = 0.4
   ParametryChoinka(1).c = 0 'mona te sprbowa 10
   ParametryChoinka(1).d = -0.1
   ParametryChoinka(1).e = 0.4
   ParametryChoinka(1).f = 0
   ParametryChoinka(2).a = -0.4
   ParametryChoinka(2).b = -0.4
   ParametryChoinka(2).c = 0
   ParametryChoinka(2).d = -0.1
   ParametryChoinka(2).e = 0.4
   ParametryChoinka(2).f = 0
   ParametryChoinka(3).a = -0.1
   ParametryChoinka(3).b = 0
   ParametryChoinka(3).c = 0
   ParametryChoinka(3).d = 0.44
   ParametryChoinka(3).e = 0.44
   ParametryChoinka(3).f = -2
   'spirala
   ParametrySpirala(0).a = -0.4
   ParametrySpirala(0).b = 0
   ParametrySpirala(0).c = -1
   ParametrySpirala(0).d = 0
   ParametrySpirala(0).e = -0.4
   ParametrySpirala(0).f = 0.1
   ParametrySpirala(1).a = 0.76
   ParametrySpirala(1).b = -0.4
   ParametrySpirala(1).c = 0
   ParametrySpirala(1).d = 0.4
   ParametrySpirala(1).e = 0.76
   ParametrySpirala(1).f = 0
   'trjkt Sierpiskiego
   ParametryTS(0).a = 0.5
   ParametryTS(0).b = 0
   ParametryTS(0).c = 0
   ParametryTS(0).d = 0
   ParametryTS(0).e = 0.5
   ParametryTS(0).f = 0
   ParametryTS(1).a = 0.5
   ParametryTS(1).b = 0
   ParametryTS(1).c = 2
   ParametryTS(1).d = 0
   ParametryTS(1).e = 0.5
   ParametryTS(1).f = 0
   ParametryTS(2).a = 0.5
   ParametryTS(2).b = 0
   ParametryTS(2).c = 1
   ParametryTS(2).d = 0
   ParametryTS(2).e = 0.5
   ParametryTS(2).f = 3 ^ (1 / 2)
End Sub

Private Sub Form_Unload(Cancel As Integer)
   blnRysuj = False
End Sub

Private Sub mnuChoinka_Click()
   mnuChoinka.Checked = True
   mnuSpirala.Checked = False
   mnuTS.Checked = False
   intFraktal = 0
   sngZoom = 150
   sngStartX = 4000
   sngStartY = 7000
End Sub

Private Sub mnuSpirala_Click()
   mnuChoinka.Checked = False
   mnuSpirala.Checked = True
   mnuTS.Checked = False
   intFraktal = 1
   sngZoom = 4000
   sngStartX = 6000
   sngStartY = 4000
End Sub

Private Sub mnuStart_Click()
   mnuStart.Enabled = False
   mnuStop.Enabled = True
   blnRysuj = True
   Rysuj
End Sub

Private Sub mnuStop_Click()
   mnuStop.Enabled = False
   mnuStart.Enabled = True
   blnRysuj = False
End Sub

Private Sub mnuTS_Click()
   mnuChoinka.Checked = False
   mnuSpirala.Checked = False
   mnuTS.Checked = True
   intFraktal = 2
   sngZoom = 1500
   sngStartX = 1500
   sngStartY = 7000
End Sub

Private Sub mnuY2Times_Click()
   mnuY2Times.Checked = Not mnuY2Times.Checked
   If mnuY2Times.Checked Then int2Y = 1 Else int2Y = 0
End Sub
